// C Source File
// Created 2/10/01; 12:51:56 PM
////////////////////////////////////








#define OPTIMIZE_ROM_CALLS 		// Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

/////////////////////////////////////////////////////////
///                  ME HEADER FILES                  ///
/////////////////////////////////////////////////////////

#include "c:\windows\desktop\MEsprites.h"	/* sprite data */
#include "c:\windows\desktop\MEvariables.h" /* variable data (global) */
#include "c:\windows\desktop\MEkeycodes.h"
#include "c:\windows\desktop\MElevels.h"


short _ti89;                  // Produce .89Z File


// speed and bullet stuff
int MAX_BULLETS=30;
int BULLET_SPEED=3000;
int DIFFICULTY=5;

/* waits */
int WAIT_FOR_NEW_MAN=4000;
int WAIT_FOR_DRAW_MAN=800;
int WAIT_FOR_DRAW=200;
int WAIT_FOR_DRAW_SHIP=250;
int WAIT_FOR_DRAW_BULLET=200;
int WAIT_FOR_DRAW_ENEMY_BULLET=300;
int CHECK_MAP=20000;
int WAIT_FOR_BULLET_S=3000;
int RECHARGE_UBD=1000;

long int canshoot=0;
int shootdelay=20;
int RADMAN=30;
BOOL rapidfire=FALSE;


int move_ship();
void  putman();


void ubd_stat()
{	//put a carrot
	DrawLine(92,1,90,7,A_NORMAL);
	DrawLine(92,1,94,7,A_NORMAL);
	
	DrawLine(100,3,ubd,3,A_XOR);
	DrawLine(100,4,ubd,4,A_XOR);
	DrawLine(100,5,ubd,5,A_XOR);
	DrawLine(100,6,ubd,6,A_XOR);
	DrawLine(100,7,ubd,7,A_XOR);
}

void putbullet_ex(int x,int y,int size)
{int i=0;
	for (i=0;i<30;i++)
	{
		if (enemy_elplosionslife[i]==NULL)
		{
			//set cords
			enemy_elplosionsx[i]=x;
			enemy_elplosionsy[i]=y;
			
			//set size for draw
			enemy_elplosionslife[i]=1;
			
			//set size of explosion
			enemy_elplosionssize[i]=size;
			
			//draw first elipse
			DrawClipEllipse(enemy_elplosionsx[i],enemy_elplosionsy[i],enemy_elplosionslife[i],enemy_elplosionslife[i],&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
			break;
		}
	}	
}

void bullet_ex()
{int i,temp;

	for (i=0;i<50;i++)
	{
		if (enemy_elplosionslife[i] != NULL)
		{	
			//erase
			DrawClipEllipse(enemy_elplosionsx[i],enemy_elplosionsy[i],enemy_elplosionslife[i],enemy_elplosionslife[i],&(SCR_RECT){{0, 11, 159, 90}},A_XOR);
			
			temp = enemy_elplosionslife[i];
			temp+=6;
			enemy_elplosionslife[i]=temp;
			//re-draw
			DrawClipEllipse(enemy_elplosionsx[i],enemy_elplosionsy[i],enemy_elplosionslife[i],enemy_elplosionslife[i],&(SCR_RECT){{0, 11, 159, 90}},A_XOR);	 
			
			if (temp >= enemy_elplosionssize[i])
			{
				DrawClipEllipse(enemy_elplosionsx[i],enemy_elplosionsy[i],enemy_elplosionslife[i],enemy_elplosionslife[i],&(SCR_RECT){{0, 11, 159, 90}},A_XOR);	 
				enemy_elplosionslife[i]=NULL;
				enemy_elplosionssize[i]=NULL;
			}
		}
	}
}








void explode(int x,int y)
{int a=0,b=4,i,C=0;
DrawClipEllipse(x,y,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);

	for (a=0;a<30;a++)
	{
		DrawClipEllipse(x,y,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
		DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
		DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
		b+=2;
		C++;


		DrawClipEllipse(x,y,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
		DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
		DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
	}

	DrawClipEllipse(x,y,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
	DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
	DrawClipEllipse(x+1,y+1,b,C,&(SCR_RECT){{0, 11, 159, 94}},A_XOR);
}


void take_ship_life()
{
	Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR); //erase ship
	explode(shipx+8,shipy+8);
	ship_life--;
	ship_strength=100;

	printf_xy(18,3,"%d  ",ship_strength);
	printf_xy(71,3,"%d  ",ship_life);
	
	Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR); //erase ship
}



/*****************************************
 *     Function: puthouses               *
 *                                       *
 *     description: put the enemy stuff  *
 *****************************************/
void puthouses(int a[])
{int r=0,x=0,y=78;


	for (x=0;x<160;x+=16)
	{

		switch (a[r++])
		{
			case 1:
				Sprite16(x,y,16,house1,LCD_MEM,SPRT_XOR);

				break;
			case 2:
				Sprite16(x,y,16,house2,LCD_MEM,SPRT_XOR);

				break;
			case 3:
				Sprite16(x,y,16,house3,LCD_MEM,SPRT_XOR);

				break;
			case 4:
				Sprite16(x,y,16,observatory,LCD_MEM,SPRT_XOR);

				break;
			case 5:
				Sprite16(x,y,16,tree,LCD_MEM,SPRT_XOR);

				break;
			case 6: //big house
				Sprite32(x,y-16,32,bighouse,LCD_MEM,SPRT_XOR);

				break;
			case 7:
				Sprite32(x,y-16,32,watertower,LCD_MEM,SPRT_XOR);

				break;
			case 8: //dimolished house
				Sprite16(x,y,16,dhouse,LCD_MEM,SPRT_XOR);

				break;
			case 9: //army base 
				Sprite32(x,y-16,32,abase,LCD_MEM,SPRT_XOR);

				break;
			case 10: //rockett launcher
				Sprite32(x,y-16,32,rlauncher,LCD_MEM,SPRT_XOR);

				break;
			case 11: //rockett laucher side
				Sprite32(x,y-16,32,rlauncherside,LCD_MEM,SPRT_XOR);

				break;
			case 12: //dish
				Sprite16(x,y,16,abdish,LCD_MEM,SPRT_XOR);

				break;
			case 13: //tank
				Sprite16(x,y,16,tank,LCD_MEM,SPRT_XOR);

				break;
			case 14: //UK missel silo
				Sprite16(x,y,16,msilo,LCD_MEM,SPRT_XOR);

				break;
			case 15: //UK missel silo
				Sprite32(x,y-16,32,china,LCD_MEM,SPRT_XOR);

				break;
		}
	}
}




void SetMapStrength(int a[])
{int i=0;
	for (i=0;i<10;i++)
	{
		switch (a[i])
		{
			case 1:
				mapstrength[i]=10;
				break;
			case 2:
				mapstrength[i]=9;
				break;
			case 3:
				mapstrength[i]=7;
				break;
			case 4:
				mapstrength[i]=12;
				break;
			case 5:
				mapstrength[i]=6;
				break;
			case 6:
				mapstrength[i]=25;
				break;
			case 7:
				mapstrength[i]=14;
				break;
			case 9:
				mapstrength[i]=30;
				break;
			case 10:
				mapstrength[i]=18;
				break;
			case 11:
				mapstrength[i]=18;
				break;
			case 12:
				mapstrength[i]=10;
				break;
			case 13:
				mapstrength[i]=12;
				break;
			case 14:
				mapstrength[i]=29;
				break;
			case 15:
				mapstrength[i]=60;
				break;
			
		}		
	}
	
}




/*******************************************
 *     Function: line                      *
 *                                         *
 * description: puts the road for the cars *
 *******************************************/
void line()
{
	int y=97,x;
	DrawLine (0,10,160,10,A_NORMAL);
	DrawLine (0,94,160,94,A_NORMAL);
	
	Sprite16(0,1,8,health8,LCD_MEM,SPRT_XOR);
	Sprite16(26,1,8,head8,LCD_MEM,SPRT_XOR);
	Sprite16(52,3,8,lives8,LCD_MEM,SPRT_XOR);
	
	printf_xy(18,3,"%d  ",ship_strength);
	printf_xy(45,3,"%d  ",man_caught);
	printf_xy(71,3,"%d  ",ship_life);
	
	for (x=0;x<160;x+=6)
	{
		DrawLine (x,y,x+3,y,A_NORMAL);
	}
	
}


/*******************************************
 *     Function: new car2,dr_car..etc...   *
 *                                         *
 * description: put the cars and move them *
 *******************************************/
void new_car2()
{int ran;

ran=random(150);

	if (ran==1)
	{
		car2x=144;
		Sprite16(car2x,car2y,16,car2,LCD_MEM,SPRT_XOR);
		car2bool=TRUE;	
	}
	else car2bool=FALSE;	
			
}

void dr_car2()
{
	if (car2bool)
	{
		Sprite16(car2x,car2y,16,car2,LCD_MEM,SPRT_XOR);
		car2x-=2;;
		Sprite16(car2x,car2y,16,car2,LCD_MEM,SPRT_XOR);
	
		if (car2x==-16)
		{
			Sprite16(car2x,car2y,16,car2,LCD_MEM,SPRT_XOR);
			car2bool=FALSE;
			new_car2();
		}
	}
	else new_car2();
	
}

void new_car()
{
int ran;
ran=random(150);
	if (ran<=5)
	{
		carx=0;
		Sprite16(carx,84,16,car,LCD_MEM,SPRT_XOR);
		carbool=TRUE;	
	}
	else carbool=FALSE;	
}

void dr_car()
{
	if (carbool)
	{
		Sprite16(carx,84,16,car,LCD_MEM,SPRT_XOR);
		carx++;
		Sprite16(carx,84,16,car,LCD_MEM,SPRT_XOR);
	
		if (carx==160)
		{
			Sprite16(carx,84,16,car,LCD_MEM,SPRT_XOR);
			carbool=FALSE;
			new_car();
		}
}
else new_car();
	
}
/*********************************************
 *         END OF CAR FUNCTIONS              *
 *********************************************/



/*******************************************
 *     Function: ch_bullets                *
 *                                         *
 * description: puts the different bullets *
 *******************************************/ 
void ch_bullets(int value,int position)
{
	switch (value)
	{
		case 1:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,bomb5,LCD_MEM,SPRT_XOR);
			break;
			
		case 2:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,bomb4,LCD_MEM,SPRT_XOR);
			break;
		case 3:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,dual_m_m,LCD_MEM,SPRT_XOR);
			break;
			
	  case 10:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,bomb3,LCD_MEM,SPRT_XOR);
			break;
		
		case 6:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,bomb2,LCD_MEM,SPRT_XOR);
			break;
		case 8:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,dual_s_b,LCD_MEM,SPRT_XOR);
			break;
		
		case 4:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,bomb1,LCD_MEM,SPRT_XOR);
			break;
		case 5:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,dual_r_b,LCD_MEM,SPRT_XOR);
			break;
			
		case 15:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,fbomb,LCD_MEM,SPRT_XOR);
			break;
		case 30:
			Sprite16(ship_bulletx[position],ship_bullety[position],8,f2bomb,LCD_MEM,SPRT_XOR);
			break;
						
		case 16:
		case 17:
			Sprite16(enemy_bulletx[position],enemy_bullety[position],8,ebullet,LCD_MEM,SPRT_XOR);
			break;
		case 18:
			Sprite16(enemy_bulletx[position],enemy_bullety[position],16,rocket_left,LCD_MEM,SPRT_XOR);
			//Sprite16(enemy_bulletx[position]+16,enemy_bullety[position]+16,16,rocket_smoke,LCD_MEM,SPRT_XOR);
			break;
		case 19:
			Sprite16(enemy_bulletx[position],enemy_bullety[position],16,rocket_up,LCD_MEM,SPRT_XOR);
			//Sprite16(enemy_bulletx[position],enemy_bullety[position]+19,16,rocket_smoke,LCD_MEM,SPRT_XOR);
			break;
		case 20:
			Sprite16(enemy_bulletx[position],enemy_bullety[position],16,rocket_right,LCD_MEM,SPRT_XOR);
			//Sprite16(enemy_bulletx[position]-24,enemy_bullety[position]+24,16,rocket_smoke,LCD_MEM,SPRT_XOR);
			break;
		case 50:
			Sprite16(enemy_bulletx[position],enemy_bullety[position],16,mega,LCD_MEM,SPRT_XOR);
			break;
	}
}		


/*******************************************
 *     Function: drawerase                 *
 *                                         *
 *    description: for drawing and erasing *
 * the screen for the broken down houses   *
 *******************************************/
void drawerase(int a[],int pos)
{
Sprite16(car2x,car2y,16,car2,LCD_MEM,SPRT_XOR);//erase cars
Sprite16(carx,84,16,car,LCD_MEM,SPRT_XOR);
Sprite16(manx,77,16,the_man,LCD_MEM,SPRT_XOR);
	puthouses(level);
	a[pos]=8;
	puthouses(level);
Sprite16(car2x,car2y,16,car2,LCD_MEM,SPRT_XOR);//redraw cars
Sprite16(carx,84,16,car,LCD_MEM,SPRT_XOR);
Sprite16(manx,77,16,the_man,LCD_MEM,SPRT_XOR);
}			 


/*******************************************
 *     Function: dr_bullets                *
 *                                         *
 *    description: moves your bullets      *
 *******************************************/
void dr_bullets()
{int i=0,tempy,temp=0;
randomize();
	for (i=0;i<MAX_BULLETS;i++)
	{
		if (ship_bulletx[i] != NULL)
		{
			
			ch_bullets(ship_bullettype[i],i); //erase old sprite
			tempy=ship_bullety[i]; //get value
			tempy+=3; //increment value
				if (tempy >= 85)
				{
					//colision of bullets
					if ((ship_bulletx[i]+7>0 && ship_bulletx[i]+7<16 && map[0]!=8))
					{
						temp=mapstrength[0];
						mapstrength[0]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[0]<=0)
					  {
					  	drawerase(level,0);
					  	mapstrength[0]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>16 && ship_bulletx[i]+7<32 && map[1]!=8))
					{
						temp=mapstrength[1];
						mapstrength[1]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[1]<=0)
					  {
					  	drawerase(level,1);
					  	mapstrength[1]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>32 && ship_bulletx[i]+7<48 && map[2]!=8))
					{
						temp=mapstrength[2];
						mapstrength[2]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[2]<=0)
					  {
					  	drawerase(level,2);
					  	mapstrength[2]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>48 && ship_bulletx[i]+7<64 && map[3]!=8))
					{
						temp=mapstrength[3];
						mapstrength[3]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[3]<=0)
					  {
					  	drawerase(level,3);
					  	mapstrength[3]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>64 && ship_bulletx[i]+7<80 && map[4]!=8))
					{
						temp=mapstrength[4];
						mapstrength[4]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[4]<=0)
					  {
					  	drawerase(level,4);
					  	mapstrength[4]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>80 && ship_bulletx[i]+7<96 && map[5]!=8))
					{
						temp=mapstrength[5];
						mapstrength[5]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;
						ship_bullety[i]=NULL;
					  if (mapstrength[5]<=0)
					  {
					  	drawerase(level,5);
					  	mapstrength[5]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>96 && ship_bulletx[i]+7<112 && map[6]!=8))
					{
						temp=mapstrength[6];
						mapstrength[6]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[6]<=0)
					  {
					  	drawerase(level,6);
					  	mapstrength[6]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>112 && ship_bulletx[i]+7<128 && map[7]!=8))
					{
						temp=mapstrength[7];
						mapstrength[7]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[7]<=0)
					  {
					  	drawerase(level,7);
					  	mapstrength[7]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>128 && ship_bulletx[i]+7<144 && map[8]!=8))
					{
						temp=mapstrength[8];
						mapstrength[8]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[8]<=0)
					  {
					  	drawerase(level,8);
					  	mapstrength[8]=0;
					  	if (random(15)==1)
					  	putman();
					  }
						break;
						
					}
					if ((ship_bulletx[i]+7>140 && ship_bulletx[i]+7<160 && map[9]!=8))
					{
						temp=mapstrength[9];
						mapstrength[9]=temp-ship_bullettype[i];
						if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion
						ship_bulletx[i]=NULL;    //no more bullet 
					  ship_bullety[i]=NULL;
					  if (mapstrength[9]<=0)
					  {
					  	drawerase(level,9);
					  	mapstrength[9]=0;
					  	if (random(15)==1)
					  	putman();
					  }
					  
						break;
						
					}
					
					if (ship_bullettype[i] >= 10 ) putbullet_ex(ship_bulletx[i]+7,ship_bullety[i],ship_bullettype[i]);	//put an explosion			
										
					ship_bulletx[i]=NULL;    //no more bullet 
					ship_bullety[i]=NULL;
					ship_bullettype[i]=NULL;
				}
			ship_bullety[i]=tempy;  //store value
			ch_bullets(ship_bullettype[i],i);  //put new sprite
			
			
		}
	}
}


/*******************************************
 *     Function: put_ship_bullet           *
 *                                         *
 *    description: put  your bullet        *
 *******************************************/
void put_ship_bullet(int x,int y,int type)
{int temp=0;
	while (ship_bulletx[temp] != NULL && temp < MAX_BULLETS)   // player may only shoot 4 bullets at a time
	{	temp++;
		if (temp == MAX_BULLETS || ship_bulletx[temp] == NULL) break;
	}
	
	if (ship_bulletx[temp]==NULL)  //if there is not a bullet there(this is a double check)
	{
		//now lets store the x value in temp in the bulletx array
		ship_bulletx[temp]=x-2;
		//now the x cord if the bullet
		ship_bullety[temp]=y+16;
		//put the sprite (bullet)
		ship_bullettype[temp]=type;
		ch_bullets(ship_bullettype[temp],temp);

	}
}

////////////////////////////////////////////////////// UNDER CONSTRUCTION //////////////////////////////
int put_enemy_bullet(int type)
{int temp=0,x=8,rad;
randomize();
	rad=random(10);
	if (mapstrength[rad]>0) //if the house is still there then put a bullet
	{	
			x=rad*16;					
	}
	else rad=NULL;  //put no bullet

	
	if (rad != NULL) 
	{
		while (enemy_bulletx[temp] != NULL && temp < MAX_BULLETS)
		{	temp++;
			if (temp == MAX_BULLETS || enemy_bulletx[temp] == NULL) break;		
		}
		
		if (enemy_bulletx[temp]==NULL)  //if there is not a bullet there(this is a double check)
		{
			//now lets store the x value in temp in the bulletx array
			enemy_bulletx[temp]=x;
			//now the y cord if the bullet
			enemy_bullety[temp]=74;
			//put the sprite (bullet)
			enemy_bullettype[temp]=type;
			ch_bullets(enemy_bullettype[temp],temp);
		}
	}
}


/*******************************************
 *     Function: dr_enemy_bullets          *
 *                                         *
 *    description: moves enemy bullets     *
 *******************************************/
void dr_enemy_bullets()
{int i=0,tempy,tempx,temp=0;
unsigned long int j=0;
	
	for (i=0;i<MAX_BULLETS;i++)
	{
		if (enemy_bulletx[i] != NULL)
		{
			//erase
			ch_bullets(enemy_bullettype[i],i); //erase old sprite
			//update
			tempy=enemy_bullety[i]; //get value
			tempx=enemy_bulletx[i]; //get value
			tempy-=1; //increment value
			if (enemy_bullettype[i]==16)
			{
				if (enemy_bulletx[i] > shipx)	tempx-=1;
				if (enemy_bulletx[i] < shipx)	tempx+=1;				
			}
			
				
			if (enemy_bullettype[i]==18 || enemy_bullettype[i]==19 || enemy_bullettype[i]==20)
			{				
				if (enemy_bulletx[i] > shipx)
				{
						
						tempx-=1;
						enemy_bullettype[i]=18;
											
				}
				if (enemy_bulletx[i] < shipx)
				{
						
						tempx+=1;
						enemy_bullettype[i]=20;
										
				}
				
				if (enemy_bulletx[i] == shipx)
				{
						
						enemy_bullettype[i]=19;
											
				}
			}
			
			enemy_bulletx[i]=tempx; //store new x cord 
			enemy_bullety[i]=tempy; //store new y cord 
			//put
			ch_bullets(enemy_bullettype[i],i);
			
				if (tempy <= 13 || tempx <= 3 || tempx > 160)	//erase sprite out of reach
				{
						ch_bullets(enemy_bullettype[i],i); //erase
						enemy_bulletx[i]=NULL;    //no more bullet 
					  enemy_bullety[i]=NULL;
			  }
			  
			////////////////////////////////////
			//////   COLLISION DETECTION ///////
			////////////////////////////////////
			if (tempx+8 >= shipx && tempx+8 <= shipx+16 && tempy > shipy && tempy < shipy+16)
			{
				 ch_bullets(enemy_bullettype[i],i); //erase
				 ship_strength -=	enemy_bullettype[i];  // damage to your ship
				 
				 putbullet_ex(enemy_bulletx[i],enemy_bullety[i],enemy_bullettype[i]-5);
				 
				 enemy_bulletx[i]=NULL;
				 enemy_bullety[i]=NULL;
				 
				 FontSetSys(F_4x6);
						printf_xy(18,3,"%d  ",ship_strength);
						
				 if (ship_strength <= 0)
				 {
				 		take_ship_life();
				 }
			} 
			
		}
	}					
}

	
	
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////


void putman(void)
{
	if (manx==NULL)
	{
		manx=2;
		Sprite16(manx,79,16,the_man,LCD_MEM,SPRT_XOR);
	}
}

void dr_man(void)
{int temp;
		if (manx != NULL)
		{
			Sprite16(manx,79,16,the_man,LCD_MEM,SPRT_XOR); //erase old man
			manx+=random(3)+1; //new possition
			
			Sprite16(manx,79,16,the_man,LCD_MEM,SPRT_XOR); //draw new man
			
			if (manx >= 144 || manx < 0)
			{
				Sprite16(manx,79,16,the_man,LCD_MEM,SPRT_XOR); //erase
				manx=NULL;
			}
		}
}

void putmenu()
{
		ClrScr();
	
		FontSetSys(F_4x6);
		DrawStr(1,2,"    ME v1.8",A_NORMAL);
		DrawStr(1,13,"by: Jimi Mudgett",A_NORMAL);
		
		
		DrawStr(1,38,"F1 - Start",A_NORMAL);
		DrawStr(1,60,"F2 - Story",A_NORMAL);
		DrawStr(1,66,"F3 - Help",A_NORMAL);
		DrawStr(1,72,"F4 - Credits",A_NORMAL);
			
}


void pressEnter()
{
	while (ngetchx() != ENTERKEY); //wait till enter key is pressed
}


void reset_vars()
{int i;
	
	carx=144;
	cary=84;
	car2x=0;
	car2y=80;
	
	shipx=64;
	shipy=20;
	
	manx=NULL;
	
	
	carbool=TRUE;
	car2bool=TRUE;
	
	for (i=0;i<50;i++)
	{
	ship_bulletx[i]=NULL;
	ship_bullety[i]=NULL;
	enemy_bulletx[i]=NULL;
	enemy_bullety[i]=NULL;
	ship_bullettype[i]=NULL;
	enemy_bullettype[i]=NULL;
	enemy_elplosionsx[i]=NULL;
	enemy_elplosionsy[i]=NULL;
	enemy_elplosionslife[i]=NULL;
	enemy_elplosionssize[i]=NULL;
	}
	
		
}

void makelevel(int a[])
{int i;
	for (i=0;i<12;i++)
		level[i]=a[i];
}

void upgrades()
{
	int i=0,position=0,y=16,key;

ClrScr();
FontSetSys(F_4x6);

	printf_xy(0,0,"Upgrades (MEN: %d)(HEALTH: %d)(LIVES: %d)",man_caught,ship_strength,ship_life);
	DrawStr(10,8,"MEN        UPGRADES ",A_NORMAL);

	DrawStr(14,16,"3      Dual Mini Mistles(F2)",A_NORMAL);
	DrawStr(14,24,"4      Dual Raptor Jets(F3)",A_NORMAL);
	DrawStr(14,32,"5      Dual Slime Bombs(F4)",A_NORMAL);
	DrawStr(14,40,"10     Dual Cowwbombs(F5)",A_NORMAL);
	DrawStr(14,48,"Return To Junk Yard",A_NORMAL);
	DrawStr(14,80,"Must have wepon Before Upgrading!",A_NORMAL);
	
	Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //draw arrow
	
	while (1)
	{
		key=ngetchx();
		if (key==UPKEY && position != 0)
		{
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //erase arrow
			y-=8;
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //draw arrow
			position--;
		}
		
		if (key==DOWNKEY && position != 4)
		{
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //erase arrow
			y+=8;
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //draw arrow
			position++;
		}
		
		if (key==ENTERKEY)
		{
			switch (position)
			{
				case 0:
					if (ship_wepons[1]==1 && man_caught >= 3)
					{
						ship_wepons[1]=2;
						man_caught-=3;					
					}
					printf_xy(0,0,"Wepon Upgrades (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					break;
					
				case 1:
					if (ship_wepons[2]==1 && man_caught >= 4)
					{
						ship_wepons[2]=2;
						man_caught-=4;					
					}
					printf_xy(0,0,"Wepon Upgrades (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					break;
					
				case 2:
					if (ship_wepons[3]==1 && man_caught >= 5)
					{
						ship_wepons[3]=2;
						man_caught-=5;					
					}
					printf_xy(0,0,"Wepon Upgrades (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					break;
				
				case 3:
					if (ship_wepons[4]==1 && man_caught >= 10)
					{
						ship_wepons[4]=2;
						man_caught-=10;					
					}
					printf_xy(0,0,"Wepon Upgrades (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					break;
				
				case 4:
					return;
			}
		}
	}	
}


/*****************************************
 *     function: the shop
 *
 *     purpose: after a call the shop 
 *     is a place for upgrading the ship
 *****************************************/

void shop()
{
int i=0,position=0,y=14,key;

shopmenu:  //for goto statement

ClrScr();
FontSetSys(F_4x6);

	printf_xy(0,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
	DrawStr(10,8,"MEN        ITEMS ",A_NORMAL);

	DrawStr(14,14,"1      +20 Heath",A_NORMAL);
	DrawStr(14,22,"3      +Your Bullet speed",A_NORMAL);
	DrawStr(14,30,"10     Quick Fire ",A_NORMAL);
	DrawStr(14,38,"10     Mini Mistles(F2)",A_NORMAL);
	DrawStr(14,46,"20     Agile Jetsv -> increse movement",A_NORMAL);
	DrawStr(14,54,"20     +50% Ubduct Recharge Speed",A_NORMAL);
	DrawStr(14,62,"25     Raptor Jets(F3)",A_NORMAL);
	DrawStr(14,70,"30     Slime Bombs(F4)",A_NORMAL);
	DrawStr(14,78,"35     Coww Bomb(F5)",A_NORMAL);
	DrawStr(14,86,"Wepon Upgrades...",A_NORMAL);
	
	Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //draw arrow
	
	while (1)
	{
		key=ngetchx();
		if (key==UPKEY && position != 0)
		{
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //erase arrow
			y-=8;
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //draw arrow
			position--;
		}
		
		if (key==DOWNKEY && position != 9)
		{
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //erase arrow
			y+=8;
			Sprite16(1,y,8,arrow,LCD_MEM,SPRT_XOR); //draw arrow
			position++;
		}
		
		if (key == ESCKEY){ ClrScr(); return;}
		
		if (key==ENTERKEY)
		{
			switch (position)
			{
				case 0:
					if (man_caught >= 1)
					{
						ship_strength+=20;
						man_caught-=1;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);						
					}
					break;
				case 1:
					if (man_caught >= 3)
					{
						WAIT_FOR_BULLET_S-=100;
						MAX_BULLETS++;
						man_caught-=3;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 2:
					if (man_caught >= 10)
					{
						rapidfire=TRUE;
						WAIT_FOR_BULLET_S=2000;
						man_caught-=10;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 3:
					if (man_caught >= 10)
					{
						ship_wepons[1]=1;
						man_caught-=10;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 4:
					if (man_caught >= 20)
					{
						jets=1;
						man_caught-=20;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 5:
					if (man_caught >= 20)
					{
						RECHARGE_UBD-=500;
						man_caught-=20;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 6:
					if (man_caught >= 25)
					{
						ship_wepons[2]=1;
						man_caught-=25;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 7:
					if (man_caught >= 30)
					{
						ship_wepons[3]=1;
						man_caught-=30;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 8:
					if (man_caught >= 35)
					{
						ship_wepons[4]=1;
						man_caught-=35;
						printf_xy(2,0,"Junk-Yard (MEN: %d) (HEALTH: %d) (LIVES: %d)",man_caught,ship_strength,ship_life);
					}
					break;
				case 9:
					ClrScr();
					upgrades();
					goto shopmenu;						
			}
			
		}
		
		
	}
	
	
	ClrScr();
	
	
	
}









void menu()
{int key=0,i=0,pl=1,score;

long int del;
long int ff;

RECHARGE_UBD=1000;
jets=0;

ship_strength=100;
ship_life=3;
man_caught=0;
			putmenu();
							
				while (1)
				{
					if(ngetchx() == ESCKEY)	exit(0);
					if(_rowread(0xfffb) & 128) {	// check for f4
						ClrScr();
									FontSetSys(F_8x10);
									DrawStr(30,1,"Credits",A_NORMAL);
									FontSetSys(F_4x6);
									DrawStr(14,20,"Names                  Work",A_NORMAL);
									DrawStr(2,28,"Nathan Zorilla      Created sprites",A_NORMAL);
									DrawStr(2,37,"Branden Russell       Game Ideas",A_NORMAL);
									
									
									DrawStr(2,54,"And, the TIGCC team",A_NORMAL);
									
									DrawStr(2,70,"Please Contact me (Jimi Mudgett)",A_NORMAL);
									DrawStr(2,78,"If you have comments, ?, or bugs",A_NORMAL);
									DrawStr(2,86,"Email:  preston_m_us@yahoo.com",A_NORMAL);
									pressEnter();
									putmenu();
										
					}	
					
					if(_rowread(0xfff7) & 128) {	// check for f3
						ClrScr();
									FontSetSys(F_8x10);
									DrawStr(30,2,"HELP",A_NORMAL);
									FontSetSys(F_4x6);
									
									DrawStr(0,14,"Arrows     -     Move",A_NORMAL);
									DrawStr(0,22,"2nd        -     Shoot",A_NORMAL);
									DrawStr(0,30,"Diamond    -     Ubduct",A_NORMAL);
									DrawStr(0,38,"Shift      -     Exit",A_NORMAL);
									DrawStr(0,46,"F2 - F5    -     Change wepons",A_NORMAL);
									DrawStr(0,54,"F1         -     The Alien Pistol",A_NORMAL);
									DrawStr(0,70,"All wepons besides the pistol",A_NORMAL);
									DrawStr(0,78,"must be bought through junk-yard",A_NORMAL);
									pressEnter();
									putmenu();
					}
					if(_rowread(0xffef) & 128) {	// check for f2
						ClrScr();
									
									FontSetSys(F_8x10);
									DrawStr(30,2,"STORY",A_NORMAL);
									FontSetSys(F_4x6);
									DrawStr(0,14,"Welcome to the ME.   You have been",A_NORMAL);
									DrawStr(0,22,"chosen to participate in a human ",A_NORMAL);
									DrawStr(0,30,"recerch project.   You have been",A_NORMAL);
									DrawStr(0,38,"Sent to earth to atempt to capture",A_NORMAL);
									DrawStr(0,46,"as many humans as possible.  In atempt",A_NORMAL);
									DrawStr(0,54,"the global millitary has came together",A_NORMAL);
									DrawStr(0,62,"to stop any further ubductions.",A_NORMAL);
									DrawStr(0,70,"Your mission is to ,get the humans,",A_NORMAL);
									DrawStr(0,78,"and protect yourself from any attack!",A_NORMAL);
									DrawStr(0,90,"            Good Luck",A_NORMAL);
									pressEnter();
									putmenu();
						
					}
				
					
					
					if(_rowread(0xffdf) & 128) {	// check for f1
						      
						      for (del=0;del<150000;del++); //delay
									for (del=0;del<150000;del++); //delay
						      
						      reset_vars(); //set vars
																
									ClrScr();
									FontSetSys(F_6x8);
										DrawStr(2,2,"Choose game difficulty!",A_NORMAL);
									FontSetSys(F_4x6);
										DrawStr(2,13,"F1 - Easy",A_NORMAL);
										DrawStr(2,21,"F2 - Normal",A_NORMAL);
										DrawStr(2,29,"F3 - Hard",A_NORMAL);
										DrawStr(2,37,"F4 - Very Hard",A_NORMAL);
										
									
									while (1)
									{
										if(_rowread(0xfffb) & 128) {	//very hard
											DIFFICULTY=1;	
											RADMAN=40;										
											break;										
										}
										
										if(_rowread(0xfff7) & 128) {	// check for f3 //hard
											DIFFICULTY=1;
											RADMAN=40;
											break;
										}
										if(_rowread(0xffef) & 128) {	// check for f2 //medium
											DIFFICULTY=1;
											RADMAN=30;
											break;	
										}
										if(_rowread(0xffdf) & 128) {	// check for f1 //easy
											DIFFICULTY=2;
											RADMAN=20;											
											break;	
										}
									}
									
									for (del=0;del<150000;del++); //delay
									for (del=0;del<150000;del++); //delay
									
									ClrScr();
									
									FontSetSys(F_6x8);
										DrawStr(2,2,"Choose game speed!",A_NORMAL);
									FontSetSys(F_4x6);
										DrawStr(2,13,"F1 - Slow",A_NORMAL);
										DrawStr(2,21,"F2 - Normal",A_NORMAL);
										DrawStr(2,29,"F3 - Fast",A_NORMAL);
										DrawStr(2,37,"F4 - Very Fast",A_NORMAL);
										
									
									while (1)
									{
										if(_rowread(0xfffb) & 128) {	//verry fast //f4
											
											MAX_BULLETS=20;
											BULLET_SPEED=3000;
																				
											/* waits */
											WAIT_FOR_NEW_MAN=2000;
											WAIT_FOR_DRAW_MAN=650;
											WAIT_FOR_DRAW=75;
											WAIT_FOR_DRAW_SHIP=100;
											WAIT_FOR_DRAW_BULLET=100;
											WAIT_FOR_DRAW_ENEMY_BULLET=200;
											WAIT_FOR_BULLET_S=2500;
											break;										
										}
										
										if(_rowread(0xfff7) & 128) {	// check for f3 //fast
											
											MAX_BULLETS=10;
											BULLET_SPEED=3000;
																				
											/* waits */
											WAIT_FOR_NEW_MAN=2000;
											WAIT_FOR_DRAW_MAN=700;
											WAIT_FOR_DRAW=100;
											WAIT_FOR_DRAW_SHIP=150;
											WAIT_FOR_DRAW_BULLET=150;
											WAIT_FOR_DRAW_ENEMY_BULLET=200;
											WAIT_FOR_BULLET_S=2000;
											break;
										}
										if(_rowread(0xffef) & 128) {	// check for f2 //medium
										
											MAX_BULLETS=10;
											BULLET_SPEED=3000;
																				
											/* waits */
											WAIT_FOR_NEW_MAN=2000;
											WAIT_FOR_DRAW_MAN=800;
											WAIT_FOR_DRAW=200;
											WAIT_FOR_DRAW_SHIP=250;
											WAIT_FOR_DRAW_BULLET=200;
											WAIT_FOR_DRAW_ENEMY_BULLET=300;
											WAIT_FOR_BULLET_S=3000;
											break;	
										}
										if(_rowread(0xffdf) & 128) {	// check for f1 //slow
											
											MAX_BULLETS=10;
											BULLET_SPEED=4000;
																				
											/* waits */
											WAIT_FOR_NEW_MAN=2000;
											WAIT_FOR_DRAW_MAN=900;
											WAIT_FOR_DRAW=300;
											WAIT_FOR_DRAW_SHIP=350;
											WAIT_FOR_DRAW_BULLET=300;
											WAIT_FOR_DRAW_ENEMY_BULLET=400;
											WAIT_FOR_BULLET_S=4000;
											break;	
										}
									}
									
									for (i=0;i<5;i++)
										ship_wepons[i]=0; // no wepons
									
									ship_wepons[0]=1;
									ShipBulletType=1;
									
									//////////////////////////////////////////////////
									///// game loop start
									//********************************************************************************************************
									//********************************************************************************************************
									//********************************************************************************************************
																		
								playagain:	
									for (pl=0;pl<31;pl++)
									{
										
										ClrScr();	//CLEAR SCREEN
										
										if (pl%2==0 || pl%2 == 5)
										{
											shop();
											ClrScr();
										}
										
										
										
										makelevel(lv_ptr[pl]);
																														
										SetMapStrength(level); //set strength
										///////////////THE GAME PLAY FUNCTIONS///////////////								
										
										puthouses(level); //houses
										line();
										new_car();
										new_car2();
										putman();
										move_ship();
																				
										/////////////////////////////////////////////////////
										
										reset_vars(); //so the screen dosent mess up
									}
									
									if (pl>=30)
									{
										ClrScr();
										FontSetSys(F_8x10);
										DrawStr(7,48,"YOU BEAT THE GAME!",A_NORMAL);
										score = 1024 * man_caught + 1 * (ship_strength + ship_life + 1);
										printf_xy(30,58,"Score: %d ",score);
										pressEnter();
										
										// play agian
										
										goto playagain;									
										
									}
									
									
									
									///////////////////////////////////////////
								  ///////// game loop end
																	
													
										
		}
	}			
}

/*******************************************
 *     Function: move_ship                 *
 *                                         *
 *    description: the name says it all    *
 *******************************************/
int move_ship()
{
// the waits for the certain sprites
unsigned long int drawcar=0,drawcar2=0,drawship=0,drawbullet=0,waitbullet=0,waitenemybullet=0,drawenemybullet=0,drawman=0,putnewman=0,waitmap=0,checkkey=0,dr_expl=0;
long int waitubd=0;


const int keywait=3000;

int key=0,sum=100,key2=0;
long int i=0;

OSSetSR(0x0700); //disable intterupts

ubd_stat(); //ad ubduction bar

	Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
	
	
	while (1)
	{
		//-----------------------------------------------
		//        check for fx keys so that bullets can
		//            change!
		//-----------------------------------------------
		if (checkkey>keywait)
		{
			if(_rowread(0xfffd) & 128) {	// check for f5 //stronges bullet
				if (ship_wepons[4]==1)				
					ShipBulletType=15;
				if (ship_wepons[4]==2)				
					ShipBulletType=30;		
			}
			if(_rowread(0xfffb) & 128) {	// check for f4
				if (ship_wepons[3]==1)
					ShipBulletType=6;
				if (ship_wepons[3]==2)				
					ShipBulletType=8;			
			}
			if(_rowread(0xfff7) & 128) {	// check for f3
				if (ship_wepons[2]==1)
					ShipBulletType=4;
				if (ship_wepons[2]==2)				
					ShipBulletType=5;		
			}
			if(_rowread(0xffef) & 128) {	// check for f2
				if (ship_wepons[1]==1)
					ShipBulletType=2;
				if (ship_wepons[1]==2)				
					ShipBulletType=3;		
			}
			if(_rowread(0xffdf) & 128) {	// check for f1
				if (ship_wepons[0]==1)
					ShipBulletType=1;
				
			}
			checkkey=0;
		}
		
		
		
		
		
		
		
		
		
		
		
		key = _rowread(TOP_ROW);  /* read key press */

		
		if (key & LEFT_KEY && shipx != 4 && drawship>=WAIT_FOR_DRAW_SHIP)
		{
			
			Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
			Sprite16(shipx-=2,shipy,16,ship,LCD_MEM,SPRT_XOR);
			
			if (jets==1)
			{
				key = _rowread(TOP_ROW);  /* read key press */
				if (key & UP_KEY && shipy > 12 && drawship>=WAIT_FOR_DRAW_SHIP)
				{
		
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx,shipy-=2,16,ship,LCD_MEM,SPRT_XOR);
					
					
				}
				
				if (key & DOWN_KEY && shipy!= 50 && drawship>=WAIT_FOR_DRAW_SHIP)
				{
		
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx,shipy+=2,16,ship,LCD_MEM,SPRT_XOR);
					
				}

			}		
			drawship=0;
		}
		

		if (key & RIGHT_KEY && shipx !=140 && drawship>=WAIT_FOR_DRAW_SHIP)
		{
			
			Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
			Sprite16(shipx+=2,shipy,16,ship,LCD_MEM,SPRT_XOR);
			if (jets==1)
			{
				key = _rowread(TOP_ROW);  /* read key press */
				if (key & UP_KEY && shipy > 12 && drawship>=WAIT_FOR_DRAW_SHIP)
				{
		
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx,shipy-=2,16,ship,LCD_MEM,SPRT_XOR);
									
				}
				
				if (key & DOWN_KEY && shipy!= 50 && drawship>=WAIT_FOR_DRAW_SHIP)
				{
		
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx,shipy+=2,16,ship,LCD_MEM,SPRT_XOR);
					
				}
			}		
			drawship=0;				
		}
		
		
		if (key & UP_KEY && shipy > 12 && drawship>=WAIT_FOR_DRAW_SHIP)
		{

			Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
			Sprite16(shipx,shipy-=2,16,ship,LCD_MEM,SPRT_XOR);
			
			if (jets==1)
			{
				key = _rowread(TOP_ROW);  /* read key press */
				if (key & LEFT_KEY && shipx != 4 && drawship>=WAIT_FOR_DRAW_SHIP)
				{					
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx-=2,shipy,16,ship,LCD_MEM,SPRT_XOR);									
				}
				
				if (key & RIGHT_KEY && shipx !=140 && drawship>=WAIT_FOR_DRAW_SHIP)
				{					
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx+=2,shipy,16,ship,LCD_MEM,SPRT_XOR);
				}
			}		
			
			drawship=0;
			
		}
		
		
		
		if (key & DOWN_KEY && shipy!= 50 && drawship>=WAIT_FOR_DRAW_SHIP)
		{

			Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
			Sprite16(shipx,shipy+=2,16,ship,LCD_MEM,SPRT_XOR);
			
			if (jets==1)
			{
				key = _rowread(TOP_ROW);  /* read key press */
				if (key & LEFT_KEY && shipx != 4 && drawship>=WAIT_FOR_DRAW_SHIP)
				{					
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx-=2,shipy,16,ship,LCD_MEM,SPRT_XOR);									
				}
				
				if (key & RIGHT_KEY && shipx !=140 && drawship>=WAIT_FOR_DRAW_SHIP)
				{					
					Sprite16(shipx,shipy,16,ship,LCD_MEM,SPRT_XOR);
					Sprite16(shipx+=2,shipy,16,ship,LCD_MEM,SPRT_XOR);
				}
			}		
			drawship=0;
		}
		
			if (key&SECOND_KEY)
			{
				if (!rapidfire)
				{
					 if(canshoot <= shootdelay)
					 {
					 	canshoot--;
					 	if (waitbullet > WAIT_FOR_BULLET_S)
					 	{
					 		put_ship_bullet(shipx,shipy,ShipBulletType);  //see if we can put another bullet
					 		waitbullet=0;
					 	}
					 }
				
					 
					 if (canshoot > shootdelay)
					 {
					 	put_ship_bullet(shipx,shipy,ShipBulletType);  //see if we can put another bullet
					 	canshoot=0;
					 	waitbullet=0;
					 }
				}else if (canshoot > shootdelay+1000 && rapidfire==TRUE)
							 {
							 	put_ship_bullet(shipx,shipy,ShipBulletType);  //see if we can put another bullet
							 	canshoot=0;
							 	waitbullet=0;
							 }
					
			}
				 
				 
				 
				 
		
		
		
		//put enemy bullet bassed on the level difficulty
		if (waitenemybullet > level[11])  //check 11th byte of array for speed, smaller is faster
		{
			if (random(DIFFICULTY)==0)
			{	switch (random(4))
				{
					case 0:
						if (level[10]>=0) //check level difficulty
							put_enemy_bullet(17);
						break;
					case 1:
						if (level[10]>=1) //check level difficulty
							put_enemy_bullet(16);
						break;
					case 2:
						if (level[10]>=2) 
							put_enemy_bullet(18);
						break;
					case 3:
						if (level[10]>=3) 
							put_enemy_bullet(50);
						break;
					
						
				}
				
			}
			waitenemybullet=0;
		}
		
		if (putnewman>=WAIT_FOR_NEW_MAN)
		{
			if (random(RADMAN)==1) //put man if random ==
			{
				putman();
			}
			putnewman=0;
		}
		
		if (drawman>=WAIT_FOR_DRAW_MAN)
		{
			dr_man();
			drawman=0;	
		}
		
		if (drawcar>=WAIT_FOR_DRAW) // these next 3 conditionals wait for the things to be drawn
		{
			drawcar=0;
			dr_car();
		}
		
		if (drawcar2>=WAIT_FOR_DRAW)
		{
			drawcar2=0;
			dr_car2();
		}
		
		if (drawbullet>=WAIT_FOR_DRAW_BULLET)
		{
			drawbullet=0;
			dr_bullets();
		}
		
		if (drawenemybullet >= WAIT_FOR_DRAW_ENEMY_BULLET)
		{
			drawenemybullet=0;
			dr_enemy_bullets();
		}
		
		if (dr_expl>400)
		{
				bullet_ex();
				dr_expl=0;
								
		}
		
		// increment the waits
		drawenemybullet++;	
		drawbullet++;
		drawship++;
		drawcar++;
		drawcar2++;
		waitbullet++;
		waitenemybullet++;
		putnewman++;
		drawman++;
		checkkey++;
		dr_expl++;
		waitubd++;
		canshoot++;
		
		if (waitubd > RECHARGE_UBD && bool_ubd==FALSE)
		{
			waitubd=0;
			ubd_stat(); //erase old line
			if (ubd < 156)	ubd++;
			if (ubd == 156) bool_ubd=TRUE;
			ubd_stat();
		}
		
		if (key&SHIFT_KEY){
			FontSetSys(F_4x6);
			DrawStr(50,50,"Paused!! press ALPHA to exit",A_XOR);
			key=_rowread(TOP_ROW);
			
			for(i=0;i<50000;i++);
			for(i=0;i<50000;i++);
			for(i=0;i<50000;i++);
			
				
			while(1)
			{
				
			key=_rowread(TOP_ROW);  //read key press again
			
				if (key&ALPHA_KEY)
				{
					OSSetSR(0x0000);
					exit(0);
				}
				
				if (key&SHIFT_KEY)
				{
					DrawStr(50,50,"Paused!! press ALPHA to exit",A_XOR);
					break;
				}
			}
			for(i=0;i<50000;i++);
			for(i=0;i<50000;i++);
			for(i=0;i<50000;i++);	
		};
		
		if (key&DIAMOND_KEY && bool_ubd == TRUE ) //if there is still power
		{
			ubd_stat(); //erase old line
			ubd--;	//make the bar go down	
			ubd_stat();
			
			if (ubd == 100)	bool_ubd=FALSE;
			
			
			DrawLine(shipx+8,shipy+10,shipx-4,90,A_XOR);
			DrawLine(shipx+8,shipy+10,shipx+20,90,A_XOR);
			
			
			DrawLine(shipx+8,shipy+10,shipx-4,90,A_XOR);
			DrawLine(shipx+8,shipy+10,shipx+20,90,A_XOR);
			
			if (manx<shipx+8 && manx>shipx-4 && manx != NULL)
			{
				Sprite16(manx,79,16,the_man,LCD_MEM,SPRT_XOR); //erase man
				man_caught++;
				FontSetSys(F_4x6);

				printf_xy(45,3,"%d  ",man_caught);

				manx=NULL;			
			}
			
			if (shipx >= 60)
			{
				drawenemybullet+=100;	
				drawbullet+=100;
				drawship+=100;
				drawcar+=100;
				drawcar2+=100;
				waitbullet+=100;
				waitenemybullet+=100;
				putnewman+=100;
				drawman+=100;
				dr_expl+=100;
			}
			
			if (shipx < 60)
			{
				drawenemybullet+=80;	
				drawbullet+=80;
				drawship+=80;
				drawcar+=80;
				drawcar2+=80;
				waitbullet+=80;
				waitenemybullet+=80;
				putnewman+=80;
				drawman+=80;
				dr_expl+=80;
			}
		
		}
		
		if (ship_life == -1){
			ClrScr();
			FontSetSys(F_8x10);
			DrawStr(40,42,"Game Over",A_NORMAL);
			ngetchx();
			ngetchx();
			OSSetSR(0x0000);
			exit(0);
		}	
		
		if (waitmap >= CHECK_MAP)
		{
			sum=0;
			
			for (i=0;i<10;i++)	//check for end of level
					sum+=mapstrength[i];
					
			waitmap=0;
		}
		
		waitmap++;
			
		if (sum <=0) return;
		
	}
		
}


// Main Function
void _main(void)
{int i;
	randomize();
	jets=0;
	
// speed and bullet stuff
MAX_BULLETS=10;
BULLET_SPEED=3000;
DIFFICULTY=5;
rapidfire=FALSE;
/* waits */
WAIT_FOR_NEW_MAN=4000;
WAIT_FOR_DRAW_MAN=800;
WAIT_FOR_DRAW=200;
WAIT_FOR_DRAW_SHIP=250;
WAIT_FOR_DRAW_BULLET=200;
WAIT_FOR_DRAW_ENEMY_BULLET=300;
CHECK_MAP=20000;

for (i=0;i<5;i++)
	ship_wepons[i]=0; // no wepons

 ship_wepons[0]=1;
 ShipBulletType=1;


 OSSetSR(0x0700);
 ubd=156;
 ClrScr();
 menu();
 
 OSSetSR(0x0000);
}




